10 '  MSX: Generatore di indici per file di messaggi
20 ' (C) Dinosoft 1988 by Enrico Colombini
22 ' (C) Enrico Colombini 1999
24 '  Liberamente duplicabile per scopi non commerciali
30 '
40 ' Istruzioni:
50 ' Questo programma legge un file testo di tipo .MSG e produce un indice
60 ' di tipo .MSX, con il quale e' possibile leggere direttamente ciascuno
70 ' dei messaggi contenuti nel file, come fa il Modulo Base BASE2.BAS.
80 '
90 ' Sintassi del file di messaggi da compilare:
100 ' Il file dev'essere in formato testo (CRLF a ogni riga) e di tipo .MSG
110 ' Il programma non va correttamente se le linee non terminano con CRLF.
120 ' Per compatibilita' con i compilatori, non superare i 79 caratteri.
130 ' Ogni messaggio va preceduto da una linea che inizia con "@",
140 ' seguito dal numero del messaggio (minimo 1). Questa linea non fa parte
150 ' del messaggio, ma serve solo per sapere dove inizia. Esempio:
160 ' @ 5
170 ' Prima di "@" non ci devono essere spazi, possono essercene tra "@" ed
180 ' il numero del messaggio. I numeri non devono essere consecutivi (anche
190 ' se e' meglio per evitare confusione), ma numeri elevati occupano spazio
200 ' inutilmente nel file .MSX (dimensioni: 6 x il numero piu' alto usato).
210 ' La lunghezza massima di un messaggio e' di 32K (spero che basti!).
220 ' L'ultimo messaggio deve terminare con un Return (a volte ci possono
230 ' essere problemi; per sicurezza si puo' aggiungere un messaggio vuoto).
240 '
250 ' Struttura del file .MSX creato:
260 ' Il file .MSX ha record di 6 byte. Ciascun record contiene informazioni
270 ' relative al messaggio con numero corrispondente. Ad esempio, il record
280 ' 37 contiene posizione iniziale (4 byte) e lunghezza (2 byte) del
290 ' messaggio numero 37 nel file .MSG
300 ' La posizione nel file e' un intero a 32 bit: il formato SNG (singola
310 ' precisione) e' incompatibile tra GWBASIC, Turbo Basic, C, etc.
320 '
330 ' Init:
340 '
350 DIM PM(2000),LM%(2000) 'Posizione e lunghezza messaggi
360 MK$ = "@" 'Marker di inizio messaggio
370 K64 = 65536! '64 Kbyte, per divisione numeri in parte H, parte L
380 MLAST = 0 'Messaggio col numero piu' alto (ultimo nell'indice)
390 '
400 ' Main:
410 '
420 PRINT:PRINT "- Generatore indice messaggi, by Enrico Colombini 1988 -":PRINT
430 INPUT "File da indicizzare (DIR per vedere i file .MSG presenti) : ",FMSG$
440 IF FMSG$="DIR" OR FMSG$="dir" THEN FILES "*.MSG":GOTO 430
450 IF FMSG$="" THEN END 'Esce se non riceve un nome (Return e basta)
460 S$ = RIGHT$(FMSG$,4) 'Aggiunge suffisso se non e' dato
470 IF S$<>".MSG" AND S$<>".msg" THEN FMSG$ = FMSG$+".MSG"
480 ON ERROR GOTO 960 'Abilita controllo errori
490 OPEN FMSG$ FOR INPUT AS #1 'Apre file messaggi da indicizzare
500 ON ERROR GOTO 0 'Spegne controllo errori
510 FMSX$ = LEFT$(FMSG$,LEN(FMSG$)-4)+".MSX" 'File indice da creare
520 MSTART = 0: MNUM = 0: 'Azzera inizio e numero messaggio
530 FPOS = 0 'Azzera indicatore posizione corrente nel file
540 TOTMSG = 0 'Azzera contatore messaggi
550 WHILE (NOT EOF(1)) 'Scandisce file
560   FPOS0 = FPOS 'Posizione prima della linea
570   LINE INPUT#1,L$ 'Legge una linea
580   FPOS = FPOS+LEN(L$)+2 'Posizione dopo la linea, incluso CRLF
590   IF LEFT$(L$,1)=MK$ THEN GOSUB 680 'Chiude messaggio, apre il prossimo
600 WEND
610 GOSUB 680 'Chiude ultimo messaggio
620 PRINT:PRINT "Scrittura file indice '";FMSX$;"'...": GOSUB 810
630 PRINT:PRINT TOTMSG;"messaggi indicizzati, per complessivi";FPOS;"caratteri."
640 PRINT:CLOSE:END
650 '
660 ' Chiude messaggio, registra dati in array, apre il successivo:
670 '
680 IF MNUM=0 GOTO 750 'Non c'e' ancora un messaggio da chiudere
690   MLEN = FPOS0-MSTART
700   IF MLEN>32767 THEN E$ = "Messaggio"+STR$(MNUM)+" troppo lungo":GOTO 1020
710   PRINT "Msg";MNUM;TAB(12);"start:";MSTART;TAB(27);"  len:";MLEN
720   TOTMSG = TOTMSG+1 'Conta messaggio
730   IF MNUM>MLAST THEN MLAST = MNUM 'Aggiorna num. ultimo messaggio
740   PM(MNUM) = MSTART: LM%(MNUM) = MLEN 'Registra in array
750 MNUM = VAL(MID$(L$,2)) 'Numero del nuovo messaggio
760 MSTART = FPOS 'E posizione del suo primo carattere
770 RETURN
780 '
790 ' Scrive file indice .MSX (0 per i messaggi inesistenti):
800 '
810 OPEN FMSX$ FOR OUTPUT AS #2: CLOSE #2 'Cancella indice se gia' esiste
820 OPEN FMSX$ AS #2 LEN=6 'Apre file indice (non dovrebbe sbagliare)
830 FIELD #2,2 AS MSL$,2 AS MSH$,2 AS ML$ 'Posizione L,H e lunghezza
840 FOR N=1 TO MLAST
850 MSTART = PM(N): MLEN = LM%(N)
860   NH = INT(MSTART/K64): NL = MSTART-NH*K64 'MOD va solo con int
870   IF NL>32767 THEN NL=NL-K64 'Riporta in int range
880   LSET MSL$ = MKI$(NL): LSET MSH$ = MKI$(NH) 'Prepara per registrare
890   LSET ML$ = MKI$(MLEN) 'Per la lunghezza bastano 16 bit
900   PUT #2,N 'Registra nel file indice i dati del messaggio
910 NEXT N
920 RETURN
930 '
940 ' Non riesce ad aprire il file di messaggi .MSG:
950 '
960 BEEP:PRINT
970 PRINT "- Non trovo alcun file '";FMSG$;"'."
980 PRINT:RESUME 430
990 '
1000 ' In caso di errore (E$ = descrizione):
1010 '
1020 BEEP:PRINT:PRINT "- Errore: ";E$;" -":BEEP
1030 CLOSE:PRINT:END
